﻿using System;
using System.Linq;
using System.Net;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SlideShareDownLoad
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            txtSlideURL.Text = "http://www.slideshare.net/chokudai/abc032";
            txtPreFix.Text = "ABC999";
        }

        //ダウンロードボタン
        private void btnDownLoad_Click(object sender, EventArgs e)
        {
            if (txtSlideURL.Text == "") return;

            this.Text = "xml取得中";

            var client = new WebClient();
            string xmlURL = "http://slideshare.net/api/oembed/2?url=";
            xmlURL += txtSlideURL.Text; //スライドのURL
            xmlURL += "&format=xml";

            string s = client.DownloadString(xmlURL);
            XDocument doc = XDocument.Parse(s);
            //MessageBox.Show(doc.ToString());

            string baseurl = doc.Descendants("slide-image-baseurl").First().Value;
            string suffixurl = doc.Descendants("slide-image-baseurl-suffix").First().Value;
            int Total = int.Parse(doc.Descendants("total-slides").First().Value);

            for (int I = 1; I <= Total; I++) {
                this.Text = string.Format("{0}をダウンロード中(残り{1})", I, Total - I);
                string DownloadURL = "http:" + baseurl;
                DownloadURL += I.ToString() + suffixurl;

                string FileName = txtPreFix.Text + "-" + I.ToString().PadLeft(3, '0') + ".png";
                string FileFullpath = System.IO.Path.Combine(GetWorkFolder(), FileName);
                client.DownloadFile(DownloadURL, FileFullpath);
            }
            this.Text = "ダウンロード完了";
        }

        //ダウンロードフォルダを開く
        private void btnFolder_Click(object sender, EventArgs e)
        {
            var InsProcessStartInfo = new System.Diagnostics.ProcessStartInfo();
            InsProcessStartInfo.FileName = GetWorkFolder();
            InsProcessStartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
            System.Diagnostics.Process.Start(InsProcessStartInfo);
        }

        //終了ボタン
        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        //DドライブがなかったらCドライブを使う
        private string GetWorkFolder()
        {
            return System.IO.Directory.Exists(@"D:\WorkFile\") ? @"D:\WorkFile\" : @"C:\WorkFile\";
        }
    }
}
